import { EventEmitter, OnChanges } from '@angular/core';
import { Dayjs } from 'dayjs';
import { DateChanged, MonthNameValue, Timepicker, YearMonthChanged } from '../types';
export declare class Calendar implements OnChanges {
    month: number;
    year: number;
    selectedFromDate: Dayjs;
    selectedToDate: Dayjs;
    isLeft: boolean;
    format: string;
    minDate: Dayjs;
    maxDate: Dayjs;
    inactiveBeforeStart: boolean;
    disableBeforeStart: boolean;
    timePicker: Timepicker;
    singleCalendar: boolean;
    weekStartsOn: number;
    addTouchSupport: boolean;
    disabledDates: Dayjs[];
    disabledDays: number[];
    disableWeekEnds: boolean;
    maxMonth: number;
    maxYear: number;
    minYear: number;
    minMonth: number;
    srFormat: string;
    dateChanged: EventEmitter<DateChanged>;
    monthChanged: EventEmitter<YearMonthChanged>;
    yearChanged: EventEmitter<YearMonthChanged>;
    scrollTop: EventEmitter<void>;
    isTouch: boolean;
    weekList: Dayjs[][];
    weekDays: string[];
    monthsList: MonthNameValue[];
    yearsList: number[];
    weekEndOn: number[];
    readonly monthText: string;
    ngOnChanges(): void;
    getNextMonthFirstWeek(): Dayjs[];
    getPreviousMonthNthLastWeek(nthLastCount: any): Dayjs[];
    createTouchCalendarGridData(): void;
    createCalendarGridData(): void;
    setWeekEnd(): void;
    setWeekDays(): void;
    isDisabled(day: Dayjs): boolean;
    isDateAvailable(day: Dayjs): boolean;
    isSelectedDate(day: any): boolean;
    getFormattedDate(day: any): any;
    scrollMeOutTop(): void;
    dateSelected(day: any): void;
    monthSelected(value: any): void;
    yearSelected(value: any): void;
}
