import { Dayjs } from 'dayjs';
export declare type Theme = 'dark' | 'light';
export declare type Position = 'left' | 'right' | 'center';
export declare class DateRange {
    start: Dayjs;
    end: Dayjs;
}
export declare class DateChanged {
    day: Dayjs;
    isLeft: boolean;
}
export declare class YearMonthChanged {
    value: number;
    isLeft: boolean;
}
export declare class MonthNameValue {
    name: string;
    value: number;
}
export declare class DefinedDateRange {
    name: string;
    value: DateRange;
}
export declare class Timepicker {
    minuteInterval: number;
    twentyFourHourFormat: boolean;
}
export declare class YearsGrid {
    startYear: number;
    numberOfYearsInOneView: number;
    yearsPerRow: number;
    yearsList: number[][];
    currentYear: number;
}
export declare class Options {
    startDate?: Dayjs;
    endDate?: Dayjs;
    minDate?: Dayjs;
    maxDate?: Dayjs;
    format?: string;
    displayFormat?: string;
    inactiveBeforeStart?: boolean;
    autoApply?: boolean;
    singleCalendar?: boolean;
    preDefinedRanges?: DefinedDateRange[];
    noDefaultRangeSelected?: boolean;
    showRanges?: boolean;
    position?: Position;
    disabled?: boolean;
    timePicker?: Timepicker;
    disableBeforeStart?: boolean;
    alwaysOpen?: boolean;
    theme?: Theme;
    required?: boolean;
    DOB?: boolean;
    weekStartsOn?: number;
    addTouchSupport?: boolean;
    placeholder?: string;
    hideControls?: boolean;
    readOnly?: boolean;
    disableWeekEnds: boolean;
    disabledDays: number[];
    disabledDates: Dayjs[];
}
